QCPGraph Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Protected Functions
QCPGraph Class Reference

A plottable representing a graph in a plot. More...

Inheritance diagram for QCPGraph:

## Public Types
enum | LineStyle
enum | ErrorType

## Public Functions
| QCPGraph (QCPAxis *keyAxis, QCPAxis *valueAxis)
QCPDataMap * | data () const
LineStyle | lineStyle () const
QCPScatterStyle | scatterStyle () const
ErrorType | errorType () const
QPen | errorPen () const
double | errorBarSize () const
bool | errorBarSkipSymbol () const
QCPGraph * | channelFillGraph () const
bool | adaptiveSampling () const
void | setData (QCPDataMap *data, bool copy=false)
void | setData (const QVector< double > &key, const QVector< double > &value)
void | setDataKeyError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &keyError)
void | setDataKeyError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &keyErrorMinus, const QVector< double > &keyErrorPlus)
void | setDataValueError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &valueError)
void | setDataValueError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &valueErrorMinus, const QVector< double > &valueErrorPlus)
void | setDataBothError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &keyError, const QVector< double > &valueError)
void | setDataBothError (const QVector< double > &key, const QVector< double > &value, const QVector< double > &keyErrorMinus, const QVector< double > &keyErrorPlus, const QVector< double > &valueErrorMinus, const QVector< double > &valueErrorPlus)
void | setLineStyle (LineStyle ls)
void | setScatterStyle (const QCPScatterStyle &style)
void | setErrorType (ErrorType errorType)
void | setErrorPen (const QPen &pen)
void | setErrorBarSize (double size)
void | setErrorBarSkipSymbol (bool enabled)
void | setChannelFillGraph (QCPGraph *targetGraph)
void | setAdaptiveSampling (bool enabled)
void | addData (const QCPDataMap &dataMap)
void | addData (const QCPData &data)
void | addData (double key, double value)
void | addData (const QVector< double > &keys, const QVector< double > &values)
void | removeDataBefore (double key)
void | removeDataAfter (double key)
void | removeData (double fromKey, double toKey)
void | removeData (double key)
virtual void | clearData ()
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
void | rescaleAxes (bool onlyEnlarge, bool includeErrorBars) const
void | rescaleKeyAxis (bool onlyEnlarge, bool includeErrorBars) const
void | rescaleValueAxis (bool onlyEnlarge, bool includeErrorBars) const
Public Functions inherited from QCPAbstractPlottable
| QCPAbstractPlottable (QCPAxis *keyAxis, QCPAxis *valueAxis)
QString | name () const
bool | antialiasedFill () const
bool | antialiasedScatters () const
bool | antialiasedErrorBars () const
QPen | pen () const
QPen | selectedPen () const
QBrush | brush () const
QBrush | selectedBrush () const
QCPAxis * | keyAxis () const
QCPAxis * | valueAxis () const
bool | selectable () const
bool | selected () const
void | setName (const QString &name)
void | setAntialiasedFill (bool enabled)
void | setAntialiasedScatters (bool enabled)
void | setAntialiasedErrorBars (bool enabled)
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setSelectedBrush (const QBrush &brush)
void | setKeyAxis (QCPAxis *axis)
void | setValueAxis (QCPAxis *axis)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
virtual bool | addToLegend ()
virtual bool | removeFromLegend () const
void | rescaleAxes (bool onlyEnlarge=false) const
void | rescaleKeyAxis (bool onlyEnlarge=false) const
void | rescaleValueAxis (bool onlyEnlarge=false) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Protected Functions
virtual void | draw (QCPPainter *painter)
virtual void | drawLegendIcon (QCPPainter *painter, const QRectF &rect) const
virtual QCPRange | getKeyRange (bool &foundRange, SignDomain inSignDomain=sdBoth) const
virtual QCPRange | getValueRange (bool &foundRange, SignDomain inSignDomain=sdBoth) const
virtual QCPRange | getKeyRange (bool &foundRange, SignDomain inSignDomain, bool includeErrors) const
virtual QCPRange | getValueRange (bool &foundRange, SignDomain inSignDomain, bool includeErrors) const
virtual void | drawFill (QCPPainter *painter, QVector< QPointF > *lineData) const
virtual void | drawScatterPlot (QCPPainter *painter, QVector< QCPData > *scatterData) const
virtual void | drawLinePlot (QCPPainter *painter, QVector< QPointF > *lineData) const
virtual void | drawImpulsePlot (QCPPainter *painter, QVector< QPointF > *lineData) const
void | getPreparedData (QVector< QCPData > *lineData, QVector< QCPData > *scatterData) const
void | getPlotData (QVector< QPointF > *lineData, QVector< QCPData > *scatterData) const
void | getScatterPlotData (QVector< QCPData > *scatterData) const
void | getLinePlotData (QVector< QPointF > *linePixelData, QVector< QCPData > *scatterData) const
void | getStepLeftPlotData (QVector< QPointF > *linePixelData, QVector< QCPData > *scatterData) const
void | getStepRightPlotData (QVector< QPointF > *linePixelData, QVector< QCPData > *scatterData) const
void | getStepCenterPlotData (QVector< QPointF > *linePixelData, QVector< QCPData > *scatterData) const
void | getImpulsePlotData (QVector< QPointF > *linePixelData, QVector< QCPData > *scatterData) const
void | drawError (QCPPainter *painter, double x, double y, const QCPData &data) const
void | getVisibleDataBounds (QCPDataMap::const_iterator &lower, QCPDataMap::const_iterator &upper) const
int | countDataInBounds (const QCPDataMap::const_iterator &lower, const QCPDataMap::const_iterator &upper, int maxCount) const
void | addFillBasePoints (QVector< QPointF > *lineData) const
void | removeFillBasePoints (QVector< QPointF > *lineData) const
QPointF | lowerFillBasePoint (double lowerKey) const
QPointF | upperFillBasePoint (double upperKey) const
const QPolygonF | getChannelFillPolygon (const QVector< QPointF > *lineData) const
int | findIndexBelowX (const QVector< QPointF > *data, double x) const
int | findIndexAboveX (const QVector< QPointF > *data, double x) const
int | findIndexBelowY (const QVector< QPointF > *data, double y) const
int | findIndexAboveY (const QVector< QPointF > *data, double y) const
double | pointDistance (const QPointF &pixelPoint) const
Protected Functions inherited from QCPAbstractPlottable
virtual QRect | clipRect () const
virtual QCP::Interaction | selectionCategory () const
void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
void | coordsToPixels (double key, double value, double &x, double &y) const
const QPointF | coordsToPixels (double key, double value) const
void | pixelsToCoords (double x, double y, double &key, double &value) const
void | pixelsToCoords (const QPointF &pixelPos, double &key, double &value) const
QPen | mainPen () const
QBrush | mainBrush () const
void | applyFillAntialiasingHint (QCPPainter *painter) const
void | applyScattersAntialiasingHint (QCPPainter *painter) const
void | applyErrorBarsAntialiasingHint (QCPPainter *painter) const
double | distSqrToLine (const QPointF &start, const QPointF &end, const QPointF &point) const
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Signals inherited from QCPAbstractPlottable
void | selectionChanged (bool selected)
void | selectableChanged (bool selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)
Protected Types inherited from QCPAbstractPlottable
enum | SignDomain

## Detailed Description

A plottable representing a graph in a plot.

Usually QCustomPlot creates graphs internally via QCustomPlot::addGraph and the resulting instance is accessed via QCustomPlot::graph.

To plot data, assign it with the setData or addData functions. Alternatively, you can also access and modify the graph's data via the data method, which returns a pointer to the internal QCPDataMap.

Graphs are used to display single-valued data. Single-valued means that there should only be one data point per unique key coordinate. In other words, the graph can't have loops. If you do want to plot non-single-valued curves, rather use the QCPCurve plottable.

Gaps in the graph line can be created by adding data points with NaN as value (`qQNaN()` or `std::numeric_limits<double>::quiet_NaN()`) in between the two data points that shall be separated.

# Changing the appearance

The appearance of the graph is mainly determined by the line style, scatter style, brush and pen of the graph (setLineStyle, setScatterStyle, setBrush, setPen).

## Filling under or between graphs

QCPGraph knows two types of fills: Normal graph fills towards the zero-value-line parallel to the key axis of the graph, and fills between two graphs, called channel fills. To enable a fill, just set a brush with setBrush which is neither Qt::NoBrush nor fully transparent.

By default, a normal fill towards the zero-value-line will be drawn. To set up a channel fill between this graph and another one, call setChannelFillGraph with the other graph as parameter.

See Also
  QCustomPlot::addGraph, QCustomPlot::graph

## Member Enumeration Documentation

enum QCPGraph::LineStyle

Defines how the graph's line is represented visually in the plot. The line is drawn with the current pen of the graph (setPen).

See Also
  setLineStyle

Enumerator
lsNone | data points are not connected with any lines (e.g. data only represented with symbols according to the scatter style, see setScatterStyle)
lsLine | data points are connected by a straight line
lsStepLeft | line is drawn as steps where the step height is the value of the left data point
lsStepRight | line is drawn as steps where the step height is the value of the right data point
lsStepCenter | line is drawn as steps where the step is in between two data points
lsImpulse | each data point is represented by a line parallel to the value axis, which reaches from the data point to the zero-value-line

enum QCPGraph::ErrorType

Defines what kind of error bars are drawn for each data point

Enumerator
etNone | No error bars are shown.
etKey | Error bars for the key dimension of the data point are shown.
etValue | Error bars for the value dimension of the data point are shown.
etBoth | Error bars for both key and value dimensions of the data point are shown.

## Constructor & Destructor Documentation

QCPGraph::QCPGraph | ( | QCPAxis * | keyAxis,
|  | QCPAxis * | valueAxis
| ) |  |
| explicit

Constructs a graph which uses keyAxis as its key axis ("x") and valueAxis as its value axis ("y"). keyAxis and valueAxis must reside in the same QCustomPlot instance and not have the same orientation. If either of these restrictions is violated, a corresponding message is printed to the debug output (qDebug), the construction is not aborted, though.

The constructed QCPGraph can be added to the plot with QCustomPlot::addPlottable, QCustomPlot then takes ownership of the graph.

To directly create a graph inside a plot, you can also use the simpler QCustomPlot::addGraph function.

## Member Function Documentation

QCPDataMap * QCPGraph::data | ( |  | ) | const
| inline

Returns a pointer to the internal data storage of type QCPDataMap. You may use it to directly manipulate the data, which may be more convenient and faster than using the regular setData or addData methods, in certain situations.

void QCPGraph::setData | ( | QCPDataMap * | data,
|  | bool | copy = `false`
| ) |  |

Replaces the current data with the provided data.

If copy is set to true, data points in data will only be copied. if false, the graph takes ownership of the passed data and replaces the internal data pointer with it. This is significantly faster than copying for large datasets.

Alternatively, you can also access and modify the graph's data via the data method, which returns a pointer to the internal QCPDataMap.

void QCPGraph::setData | ( | const QVector< double > & | key,
|  | const QVector< double > & | value
| ) |  |

This is an overloaded function.

Replaces the current data with the provided points in key and value pairs. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

void QCPGraph::setDataKeyError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | keyError
| ) |  |

Replaces the current data with the provided points in key and value pairs. Additionally the symmetrical key error of the data points are set to the values in keyError. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

For asymmetrical errors (plus different from minus), see the overloaded version of this function.

void QCPGraph::setDataKeyError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | keyErrorMinus,
|  | const QVector< double > & | keyErrorPlus
| ) |  |

This is an overloaded function. Replaces the current data with the provided points in key and value pairs. Additionally the negative key error of the data points are set to the values in keyErrorMinus, the positive key error to keyErrorPlus. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

void QCPGraph::setDataValueError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | valueError
| ) |  |

Replaces the current data with the provided points in key and value pairs. Additionally the symmetrical value error of the data points are set to the values in valueError. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

For asymmetrical errors (plus different from minus), see the overloaded version of this function.

void QCPGraph::setDataValueError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | valueErrorMinus,
|  | const QVector< double > & | valueErrorPlus
| ) |  |

This is an overloaded function. Replaces the current data with the provided points in key and value pairs. Additionally the negative value error of the data points are set to the values in valueErrorMinus, the positive value error to valueErrorPlus. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

void QCPGraph::setDataBothError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | keyError,
|  | const QVector< double > & | valueError
| ) |  |

Replaces the current data with the provided points in key and value pairs. Additionally the symmetrical key and value errors of the data points are set to the values in keyError and valueError. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

For asymmetrical errors (plus different from minus), see the overloaded version of this function.

void QCPGraph::setDataBothError | ( | const QVector< double > & | key,
|  | const QVector< double > & | value,
|  | const QVector< double > & | keyErrorMinus,
|  | const QVector< double > & | keyErrorPlus,
|  | const QVector< double > & | valueErrorMinus,
|  | const QVector< double > & | valueErrorPlus
| ) |  |

This is an overloaded function. Replaces the current data with the provided points in key and value pairs. Additionally the negative key and value errors of the data points are set to the values in keyErrorMinus and valueErrorMinus. The positive key and value errors are set to the values in keyErrorPlus valueErrorPlus. For error bars to show appropriately, see setErrorType. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

void QCPGraph::setLineStyle | ( | LineStyle | ls | ) |

Sets how the single data points are connected in the plot. For scatter-only plots, set ls to lsNone and setScatterStyle to the desired scatter style.

See Also
  setScatterStyle

void QCPGraph::setScatterStyle | ( | const QCPScatterStyle & | style | ) |

Sets the visual appearance of single data points in the plot. If set to QCPScatterStyle::ssNone, no scatter points are drawn (e.g. for line-only-plots with appropriate line style).

See Also
  QCPScatterStyle, setLineStyle

void QCPGraph::setErrorType | ( | ErrorType | errorType | ) |

Sets which kind of error bars (Key Error, Value Error or both) should be drawn on each data point. If you set errorType to something other than etNone, make sure to actually pass error data via the specific setData functions along with the data points (e.g. setDataValueError, setDataKeyError, setDataBothError).

See Also
  ErrorType

void QCPGraph::setErrorPen | ( | const QPen & | pen | ) |

Sets the pen with which the error bars will be drawn.

See Also
  setErrorBarSize, setErrorType

void QCPGraph::setErrorBarSize | ( | double | size | ) |

Sets the width of the handles at both ends of an error bar in pixels.

void QCPGraph::setErrorBarSkipSymbol | ( | bool | enabled | ) |

If enabled is set to true, the error bar will not be drawn as a solid line under the scatter symbol but leave some free space around the symbol.

This feature uses the current scatter size (QCPScatterStyle::setSize) to determine the size of the area to leave blank. So when drawing Pixmaps as scatter points (QCPScatterStyle::ssPixmap), the scatter size must be set manually to a value corresponding to the size of the Pixmap, if the error bars should leave gaps to its boundaries.

setErrorType, setErrorBarSize, setScatterStyle

void QCPGraph::setChannelFillGraph | ( | QCPGraph * | targetGraph | ) |

Sets the target graph for filling the area between this graph and targetGraph with the current brush (setBrush).

When targetGraph is set to 0, a normal graph fill to the zero-value-line will be shown. To disable any filling, set the brush to Qt::NoBrush.

See Also
  setBrush

void QCPGraph::setAdaptiveSampling | ( | bool | enabled | ) |

Sets whether adaptive sampling shall be used when plotting this graph. QCustomPlot's adaptive sampling technique can drastically improve the replot performance for graphs with a larger number of points (e.g. above 10,000), without notably changing the appearance of the graph.

By default, adaptive sampling is enabled. Even if enabled, QCustomPlot decides whether adaptive sampling shall actually be used on a per-graph basis. So leaving adaptive sampling enabled has no disadvantage in almost all cases.

A line plot of 500,000 points without and with adaptive sampling

As can be seen, line plots experience no visual degradation from adaptive sampling. Outliers are reproduced reliably, as well as the overall shape of the data set. The replot time reduces dramatically though. This allows QCustomPlot to display large amounts of data in realtime.

A scatter plot of 100,000 points without and with adaptive sampling

Care must be taken when using high-density scatter plots in combination with adaptive sampling. The adaptive sampling algorithm treats scatter plots more carefully than line plots which still gives a significant reduction of replot times, but not quite as much as for line plots. This is because scatter plots inherently need more data points to be preserved in order to still resemble the original, non-adaptive-sampling plot. As shown above, the results still aren't quite identical, as banding occurs for the outer data points. This is in fact intentional, such that the boundaries of the data cloud stay visible to the viewer. How strong the banding appears, depends on the point density, i.e. the number of points in the plot.

For some situations with scatter plots it might thus be desirable to manually turn adaptive sampling off. For example, when saving the plot to disk. This can be achieved by setting enabled to false before issuing a command like QCustomPlot::savePng, and setting enabled back to true afterwards.

void QCPGraph::addData | ( | const QCPDataMap & | dataMap | ) |

Adds the provided data points in dataMap to the current data.

Alternatively, you can also access and modify the graph's data via the data method, which returns a pointer to the internal QCPDataMap.

See Also
  removeData

void QCPGraph::addData | ( | const QCPData & | data | ) |

This is an overloaded function. Adds the provided single data point in data to the current data.

Alternatively, you can also access and modify the graph's data via the data method, which returns a pointer to the internal QCPDataMap.

See Also
  removeData

void QCPGraph::addData | ( | double | key,
|  | double | value
| ) |  |

This is an overloaded function. Adds the provided single data point as key and value pair to the current data.

Alternatively, you can also access and modify the graph's data via the data method, which returns a pointer to the internal QCPDataMap.

See Also
  removeData

void QCPGraph::addData | ( | const QVector< double > & | keys,
|  | const QVector< double > & | values
| ) |  |

This is an overloaded function. Adds the provided data points as key and value pairs to the current data.

Alternatively, you can also access and modify the graph's data via the data method, which returns a pointer to the internal QCPDataMap.

See Also
  removeData

void QCPGraph::removeDataBefore | ( | double | key | ) |

Removes all data points with keys smaller than key.

See Also
  addData, clearData

void QCPGraph::removeDataAfter | ( | double | key | ) |

Removes all data points with keys greater than key.

See Also
  addData, clearData

void QCPGraph::removeData | ( | double | fromKey,
|  | double | toKey
| ) |  |

Removes all data points with keys between fromKey and toKey. if fromKey is greater or equal to toKey, the function does nothing. To remove a single data point with known key, use removeData(double key).

See Also
  addData, clearData

void QCPGraph::removeData | ( | double | key | ) |

This is an overloaded function.

Removes a single data point at key. If the position is not known with absolute precision, consider using removeData(double fromKey, double toKey) with a small fuzziness interval around the suspected position, depeding on the precision with which the key is known.

See Also
  addData, clearData

void QCPGraph::clearData | ( |  | ) |
| virtual

Removes all data points.

See Also
  removeData, removeDataAfter, removeDataBefore

Implements QCPAbstractPlottable.

double QCPGraph::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the object is represented not by single lines but by an area like a QCPItemText or the bars of a QCPBars plottable, a click inside the area should also be considered a hit. In these cases this function thus returns a constant value greater zero but still below the parent plot's selection tolerance. (typically the selectionTolerance multiplied by 0.99).

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

You may pass 0 as details to indicate that you are not interested in those selection details.

See Also
  selectEvent, deselectEvent, QCustomPlot::setInteractions

Implements QCPAbstractPlottable.

void QCPGraph::rescaleAxes | ( | bool | onlyEnlarge,
|  | bool | includeErrorBars
| ) |  | const

This is an overloaded function.

Allows to define whether error bars are taken into consideration when determining the new axis range.

See Also
  rescaleKeyAxis, rescaleValueAxis, QCPAbstractPlottable::rescaleAxes, QCustomPlot::rescaleAxes

void QCPGraph::rescaleKeyAxis | ( | bool | onlyEnlarge,
|  | bool | includeErrorBars
| ) |  | const

This is an overloaded function.

Allows to define whether error bars (of kind QCPGraph::etKey) are taken into consideration when determining the new axis range.

See Also
  rescaleAxes, QCPAbstractPlottable::rescaleKeyAxis

void QCPGraph::rescaleValueAxis | ( | bool | onlyEnlarge,
|  | bool | includeErrorBars
| ) |  | const

This is an overloaded function.

Allows to define whether error bars (of kind QCPGraph::etValue) are taken into consideration when determining the new axis range.

See Also
  rescaleAxes, QCPAbstractPlottable::rescaleValueAxis

void QCPGraph::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

This function draws the layerable with the specified painter. It is only called by QCustomPlot, if the layerable is visible (setVisible).

Before this function is called, the painter's antialiasing state is set via applyDefaultAntialiasingHint, see the documentation there. Further, the clipping rectangle was set to clipRect.

Implements QCPAbstractPlottable.

void QCPGraph::drawLegendIcon | ( | QCPPainter * | painter,
|  | const QRectF & | rect
| ) |  | const
| protectedvirtual

called by QCPLegend::draw (via QCPPlottableLegendItem::draw) to create a graphical representation of this plottable inside rect, next to the plottable name.

The passed painter has its cliprect set to rect, so painting outside of rect won't appear outside the legend icon border.

Implements QCPAbstractPlottable.

QCPRange QCPGraph::getKeyRange | ( | bool & | foundRange,
|  | SignDomain | inSignDomain = `sdBoth`
| ) |  | const
| protectedvirtual

called by rescaleAxes functions to get the full data key bounds. For logarithmic plots, one can set inSignDomain to either sdNegative or sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero, which wouldn't count as a valid range.

See Also
  rescaleAxes, getValueRange

Implements QCPAbstractPlottable.

QCPRange QCPGraph::getValueRange | ( | bool & | foundRange,
|  | SignDomain | inSignDomain = `sdBoth`
| ) |  | const
| protectedvirtual

called by rescaleAxes functions to get the full data value bounds. For logarithmic plots, one can set inSignDomain to either sdNegative or sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero, which wouldn't count as a valid range.

See Also
  rescaleAxes, getKeyRange

Implements QCPAbstractPlottable.

QCPRange QCPGraph::getKeyRange | ( | bool & | foundRange,
|  | SignDomain | inSignDomain,
|  | bool | includeErrors
| ) |  | const
| protectedvirtual

This is an overloaded function.

Allows to specify whether the error bars should be included in the range calculation.

See Also
  getKeyRange(bool &foundRange, SignDomain inSignDomain)

QCPRange QCPGraph::getValueRange | ( | bool & | foundRange,
|  | SignDomain | inSignDomain,
|  | bool | includeErrors
| ) |  | const
| protectedvirtual

This is an overloaded function.

Allows to specify whether the error bars should be included in the range calculation.

See Also
  getValueRange(bool &foundRange, SignDomain inSignDomain)

void QCPGraph::drawFill | ( | QCPPainter * | painter,
|  | QVector< QPointF > * | lineData
| ) |  | const
| protectedvirtual

Draws the fill of the graph with the specified brush.

If the fill is a normal fill towards the zero-value-line, only the lineData is required (and two extra points at the zero-value-line, which are added by addFillBasePoints and removed by removeFillBasePoints after the fill drawing is done).

If the fill is a channel fill between this QCPGraph and another QCPGraph (mChannelFillGraph), the more complex polygon is calculated with the getChannelFillPolygon function.

See Also
  drawLinePlot

void QCPGraph::drawScatterPlot | ( | QCPPainter * | painter,
|  | QVector< QCPData > * | scatterData
| ) |  | const
| protectedvirtual

Draws scatter symbols at every data point passed in scatterData. scatter symbols are independent of the line style and are always drawn if the scatter style's shape is not QCPScatterStyle::ssNone. Hence, the scatterData vector is outputted by all "get(...)PlotData" functions, together with the (line style dependent) line data.

See Also
  drawLinePlot, drawImpulsePlot

void QCPGraph::drawLinePlot | ( | QCPPainter * | painter,
|  | QVector< QPointF > * | lineData
| ) |  | const
| protectedvirtual

Draws line graphs from the provided data. It connects all points in lineData, which was created by one of the "get(...)PlotData" functions for line styles that require simple line connections between the point vector they create. These are for example getLinePlotData, getStepLeftPlotData, getStepRightPlotData and getStepCenterPlotData.

See Also
  drawScatterPlot, drawImpulsePlot

void QCPGraph::drawImpulsePlot | ( | QCPPainter * | painter,
|  | QVector< QPointF > * | lineData
| ) |  | const
| protectedvirtual

Draws impulses from the provided data, i.e. it connects all line pairs in lineData, which was created by getImpulsePlotData.

See Also
  drawScatterPlot, drawLinePlot

void QCPGraph::getPreparedData | ( | QVector< QCPData > * | lineData,
|  | QVector< QCPData > * | scatterData
| ) |  | const
| protected

Returns the lineData and scatterData that need to be plotted for this graph taking into consideration the current axis ranges and, if setAdaptiveSampling is enabled, local point densities.

0 may be passed as lineData or scatterData to indicate that the respective dataset isn't needed. For example, if the scatter style (setScatterStyle) is QCPScatterStyle::ssNone, scatterData should be 0 to prevent unnecessary calculations.

This method is used by the various "get(...)PlotData" methods to get the basic working set of data.

void QCPGraph::getPlotData | ( | QVector< QPointF > * | lineData,
|  | QVector< QCPData > * | scatterData
| ) |  | const
| protected

This function branches out to the line style specific "get(...)PlotData" functions, according to the line style of the graph.

lineData will be filled with raw points that will be drawn with the according draw functions, e.g. drawLinePlot and drawImpulsePlot. These aren't necessarily the original data points, since for step plots for example, additional points are needed for drawing lines that make up steps. If the line style of the graph is lsNone, the lineData vector will be left untouched.

scatterData will be filled with the original data points so drawScatterPlot can draw the scatter symbols accordingly. If no scatters need to be drawn, i.e. the scatter style's shape is QCPScatterStyle::ssNone, pass 0 as scatterData, and this step will be skipped.

See Also
  getScatterPlotData, getLinePlotData, getStepLeftPlotData, getStepRightPlotData, getStepCenterPlotData, getImpulsePlotData

void QCPGraph::getScatterPlotData | ( | QVector< QCPData > * | scatterData | ) | const
| protected

If line style is lsNone and the scatter style's shape is not QCPScatterStyle::ssNone, this function serves at providing the visible data points in scatterData, so the drawScatterPlot function can draw the scatter points accordingly.

If line style is not lsNone, this function is not called and the data for the scatter points are (if needed) calculated inside the corresponding other "get(...)PlotData" functions.

See Also
  drawScatterPlot

void QCPGraph::getLinePlotData | ( | QVector< QPointF > * | linePixelData,
|  | QVector< QCPData > * | scatterData
| ) |  | const
| protected

Places the raw data points needed for a normal linearly connected graph in linePixelData.

As for all plot data retrieval functions, scatterData just contains all unaltered data (scatter) points that are visible for drawing scatter points, if necessary. If drawing scatter points is disabled (i.e. the scatter style's shape is QCPScatterStyle::ssNone), pass 0 as scatterData, and the function will skip filling the vector.

See Also
  drawLinePlot

void QCPGraph::getStepLeftPlotData | ( | QVector< QPointF > * | linePixelData,
|  | QVector< QCPData > * | scatterData
| ) |  | const
| protected

Places the raw data points needed for a step plot with left oriented steps in lineData.

As for all plot data retrieval functions, scatterData just contains all unaltered data (scatter) points that are visible for drawing scatter points, if necessary. If drawing scatter points is disabled (i.e. the scatter style's shape is QCPScatterStyle::ssNone), pass 0 as scatterData, and the function will skip filling the vector.

See Also
  drawLinePlot

void QCPGraph::getStepRightPlotData | ( | QVector< QPointF > * | linePixelData,
|  | QVector< QCPData > * | scatterData
| ) |  | const
| protected

Places the raw data points needed for a step plot with right oriented steps in lineData.

As for all plot data retrieval functions, scatterData just contains all unaltered data (scatter) points that are visible for drawing scatter points, if necessary. If drawing scatter points is disabled (i.e. the scatter style's shape is QCPScatterStyle::ssNone), pass 0 as scatterData, and the function will skip filling the vector.

See Also
  drawLinePlot

void QCPGraph::getStepCenterPlotData | ( | QVector< QPointF > * | linePixelData,
|  | QVector< QCPData > * | scatterData
| ) |  | const
| protected

Places the raw data points needed for a step plot with centered steps in lineData.

As for all plot data retrieval functions, scatterData just contains all unaltered data (scatter) points that are visible for drawing scatter points, if necessary. If drawing scatter points is disabled (i.e. the scatter style's shape is QCPScatterStyle::ssNone), pass 0 as scatterData, and the function will skip filling the vector.

See Also
  drawLinePlot

void QCPGraph::getImpulsePlotData | ( | QVector< QPointF > * | linePixelData,
|  | QVector< QCPData > * | scatterData
| ) |  | const
| protected

Places the raw data points needed for an impulse plot in lineData.

As for all plot data retrieval functions, scatterData just contains all unaltered data (scatter) points that are visible for drawing scatter points, if necessary. If drawing scatter points is disabled (i.e. the scatter style's shape is QCPScatterStyle::ssNone), pass 0 as scatterData, and the function will skip filling the vector.

See Also
  drawImpulsePlot

void QCPGraph::drawError | ( | QCPPainter * | painter,
|  | double | x,
|  | double | y,
|  | const QCPData & | data
| ) |  | const
| protected

called by the scatter drawing function (drawScatterPlot) to draw the error bars on one data point. x and y pixel positions of the data point are passed since they are already known in pixel coordinates in the drawing function, so we save some extra coordToPixel transforms here. data is therefore only used for the errors, not key and value.

void QCPGraph::getVisibleDataBounds | ( | QCPDataMap::const_iterator & | lower,
|  | QCPDataMap::const_iterator & | upper
| ) |  | const
| protected

called by getPreparedData to determine which data (key) range is visible at the current key axis range setting, so only that needs to be processed.

lower returns an iterator to the lowest data point that needs to be taken into account when plotting. Note that in order to get a clean plot all the way to the edge of the axis rect, lower may still be just outside the visible range.

upper returns an iterator to the highest data point. Same as before, upper may also lie just outside of the visible range.

if the graph contains no data, both lower and upper point to constEnd.

int QCPGraph::countDataInBounds | ( | const QCPDataMap::const_iterator & | lower,
|  | const QCPDataMap::const_iterator & | upper,
|  | int | maxCount
| ) |  | const
| protected

Counts the number of data points between lower and upper (including them), up to a maximum of maxCount.

This function is used by getPreparedData to determine whether adaptive sampling shall be used (if enabled via setAdaptiveSampling) or not. This is also why counting of data points only needs to be done until maxCount is reached, which should be set to the number of data points at which adaptive sampling sets in.

void QCPGraph::addFillBasePoints | ( | QVector< QPointF > * | lineData | ) | const
| protected

The line data vector generated by e.g. getLinePlotData contains only the line that connects the data points. If the graph needs to be filled, two additional points need to be added at the value-zero-line in the lower and upper key positions of the graph. This function calculates these points and adds them to the end of lineData. Since the fill is typically drawn before the line stroke, these added points need to be removed again after the fill is done, with the removeFillBasePoints function.

The expanding of lineData by two points will not cause unnecessary memory reallocations, because the data vector generation functions (getLinePlotData etc.) reserve two extra points when they allocate memory for lineData.

See Also
  removeFillBasePoints, lowerFillBasePoint, upperFillBasePoint

void QCPGraph::removeFillBasePoints | ( | QVector< QPointF > * | lineData | ) | const
| protected

removes the two points from lineData that were added by addFillBasePoints.

See Also
  addFillBasePoints, lowerFillBasePoint, upperFillBasePoint

QPointF QCPGraph::lowerFillBasePoint | ( | double | lowerKey | ) | const
| protected

called by addFillBasePoints to conveniently assign the point which closes the fill polygon on the lower side of the zero-value-line parallel to the key axis. The logarithmic axis scale case is a bit special, since the zero-value-line in pixel coordinates is in positive or negative infinity. So this case is handled separately by just closing the fill polygon on the axis which lies in the direction towards the zero value.

lowerKey will be the the key (in pixels) of the returned point. Depending on whether the key axis is horizontal or vertical, lowerKey will end up as the x or y value of the returned point, respectively.

See Also
  upperFillBasePoint, addFillBasePoints

QPointF QCPGraph::upperFillBasePoint | ( | double | upperKey | ) | const
| protected

called by addFillBasePoints to conveniently assign the point which closes the fill polygon on the upper side of the zero-value-line parallel to the key axis. The logarithmic axis scale case is a bit special, since the zero-value-line in pixel coordinates is in positive or negative infinity. So this case is handled separately by just closing the fill polygon on the axis which lies in the direction towards the zero value.

upperKey will be the the key (in pixels) of the returned point. Depending on whether the key axis is horizontal or vertical, upperKey will end up as the x or y value of the returned point, respectively.

See Also
  lowerFillBasePoint, addFillBasePoints

const QPolygonF QCPGraph::getChannelFillPolygon | ( | const QVector< QPointF > * | lineData | ) | const
| protected

Generates the polygon needed for drawing channel fills between this graph (data passed via lineData) and the graph specified by mChannelFillGraph (data generated by calling its getPlotData function). May return an empty polygon if the key ranges have no overlap or fill target graph and this graph don't have same orientation (i.e. both key axes horizontal or both key axes vertical). For increased performance (due to implicit sharing), keep the returned QPolygonF const.

int QCPGraph::findIndexBelowX | ( | const QVector< QPointF > * | data,
|  | double | x
| ) |  | const
| protected

Finds the highest index of data, whose points x value is just below x. Assumes x values in data points are ordered ascending, as is the case when plotting with horizontal key axis.

Used to calculate the channel fill polygon, see getChannelFillPolygon.

int QCPGraph::findIndexAboveX | ( | const QVector< QPointF > * | data,
|  | double | x
| ) |  | const
| protected

Finds the smallest index of data, whose points x value is just above x. Assumes x values in data points are ordered ascending, as is the case when plotting with horizontal key axis.

Used to calculate the channel fill polygon, see getChannelFillPolygon.

int QCPGraph::findIndexBelowY | ( | const QVector< QPointF > * | data,
|  | double | y
| ) |  | const
| protected

Finds the highest index of data, whose points y value is just below y. Assumes y values in data points are ordered descending, as is the case when plotting with vertical key axis (since keys are ordered ascending).

Used to calculate the channel fill polygon, see getChannelFillPolygon.

int QCPGraph::findIndexAboveY | ( | const QVector< QPointF > * | data,
|  | double | y
| ) |  | const
| protected

Finds the smallest index of data, whose points y value is just above y. Assumes y values in data points are ordered descending, as is the case when plotting with vertical key axis.

Used to calculate the channel fill polygon, see getChannelFillPolygon.

double QCPGraph::pointDistance | ( | const QPointF & | pixelPoint | ) | const
| protected

Calculates the (minimum) distance (in pixels) the graph's representation has from the given pixelPoint in pixels. This is used to determine whether the graph was clicked or not, e.g. in selectTest.

If either the graph has no data or if the line style is lsNone and the scatter style's shape is QCPScatterStyle::ssNone (i.e. there is no visual representation of the graph), returns -1.0.

The documentation for this class was generated from the following files:

- src/plottables/plottable-graph.h
- src/plottables/plottable-graph.cpp